#@+leo
#@+node:0::@file sayzmef.py
#@+body
#this is my firtst crude attempt at using festival 
#not using client/server, just writing text to file
#and getting festival to do file to speech thing
#it works ok on my win2k box - but haven't yet 
#learnt enough scheme to work out how to get 
#the currently spoken word for highlighting


#@<<imports>>
#@+node:1::<<imports>>
#@+body
import sys
import os
from Tkinter import *
root = Tk()
import tkMessageBox
import Pmw
import win32clipboard
import win32con,re
import win32api
import cPickle
import string
import time
import win32pipe


#@-body
#@-node:1::<<imports>>


#@<<dialog about>>
#@+node:2::<<dialog about>>
#@+body
class AboutMe:

	def __init__(self):
		dialog = Toplevel()
		dialog.title("about Sayz Me")
		dialog.iconname('sayzme')
		dialog.iconbitmap('sayzme.ico')
		frame_about = Frame(dialog)
		frame_about.pack(sid=TOP, fill=BOTH, expand=1)
		self.scrollabout = Scrollbar(frame_about, orient='vertical')
		self.scrollabout.pack (fill=Y, side=RIGHT)
		self.textabout = Text(frame_about, 
		wrap='word',
		background='white',
		width=80,
		yscrollcommand=self.scrollabout.set,
		padx=4, pady=4)
		self.textabout.pack (side=TOP, fill=BOTH, expand=YES, padx = 5, pady = 5)
		self.scrollabout.config(command=self.textabout.yview)

		self.textabout.tag_config('head1', foreground = 'black', font='Arial 12 bold', justify='center')		
		self.textabout.tag_config('head2', foreground = 'black', font='Arial 10', justify='center')		
		self.textabout.tag_config('head3', foreground = 'black', font='Arial 10 bold')
		self.textabout.tag_config('norm', foreground = 'black', font='Arial 10')
		self.textabout.tag_config('hlink', foreground = 'blue', underline=1, font='Arial 10')
		self.textabout.tag_config('point', foreground = 'black', font='Arial 10', lmargin1=10, lmargin2=18)
		self.textabout.tag_bind("hlink", "<Button-1>", self.openHLink)		
		self.textabout.tag_bind('hlink', '<Enter>', self.hand_cursor)
		self.textabout.tag_bind('hlink', '<Leave>', self.normal_cursor)

		
		self.textabout.insert(END,"Sayz Me - Version 0.2\n\n", 'head1')
		self.textabout.insert(END,"(c) Copyright 2002. Adam Bunter. All Rights Reserved. \n\n", 'head2')
		#intro
		self.textabout.insert(END, 'Introduction', 'head3')			
		self.textabout.insert(END, '\n\n', 'norm')				
		info = "Sayz Me is a simple text-to-speech application written in Python " \
		"and distributed freely under a BSD style license."
		self.textabout.insert(END, info, 'norm')			
		self.textabout.insert(END, '\n\n', 'norm')		
		#example use
		self.textabout.insert(END, 'Sayz Me Example Use', 'head3')			
		self.textabout.insert(END, '\n\n', 'norm')		
		info = '1. Open your web browser and jump to your favourite web site.\n' \
		'2. Highlight and copy some text.\n' \
		'3. Sayz Me will maximize and begin reading the copied text.\n\n'  \
		'Tip: double-click to jump to a particular word.'
		self.textabout.insert(END, info, 'norm')			
		self.textabout.insert(END, '\n\n', 'norm')		
		
		#controls
		self.textabout.insert(END, 'Controls', 'head3')			
		self.textabout.insert(END, '\n\n', 'norm')		
		info = 'Pause Button - yeah, you guessed it, pauses the speaking of text.\n'
		self.textabout.insert(END, info, 'norm')		
		info = 'Read Button - reads the text that has been copied or typed into the program.\n'
		self.textabout.insert(END, info, 'norm')			
		info = 'Reset Button - stop reading, clear displayed text and empty the clipboard.\n'
		self.textabout.insert(END, info, 'norm')			
		info = 'Exit Button - uhhu, it exits the program.'
		self.textabout.insert(END, info, 'norm')			
		self.textabout.insert(END, '\n\n', 'norm')				
		
		#menu options
		self.textabout.insert(END, 'Menu >> Options', 'head3')			
		self.textabout.insert(END, '\n\n', 'norm')								
		info = 'Listen to Clipboard - automatically read any text copied onto the clipboard.\n'
		self.textabout.insert(END, info, 'norm')		
		info = 'Empty Clipboard - empty the clipboard once reading begins.\n'
		self.textabout.insert(END, info, 'norm')			
		info = 'Bring to Top - maximize before reading copied text.\n'
		self.textabout.insert(END, info, 'norm')					
		info = 'Minimize after Speaking - minimize after reading is completed.'
		self.textabout.insert(END, info, 'norm')		
		self.textabout.insert(END, '\n\n', 'norm')		
		
		#settings
		self.textabout.insert(END, 'Menu >> Options >> Settings...', 'head3')			
		self.textabout.insert(END, '\n\n', 'norm')							
		info = 'Highlight Color - the color of the currently spoken text. \n'
		self.textabout.insert(END, info, 'norm')		
		info = 'Highlight Characters - number of characters highlighted while reading.\n'
		self.textabout.insert(END, info, 'norm')				
		info = 'Speed - the rate at which the voice reads the text.\n'
		self.textabout.insert(END, info, 'norm')				
		info = 'Pitch  - the tone of the speakers voice.\n'
		self.textabout.insert(END, info, 'norm')				
		self.textabout.insert(END, '\n', 'norm')	
		
		#acknowledgements					
		self.textabout.insert(END, 'Acknowledgements', 'head3')			        
		self.textabout.insert(END, '\n\n', 'norm')				
		self.textabout.insert(END, 'OSI - ' , 'norm')	
		self.textabout.insert(END, 'http://www.opensource.org/' , 'hlink')			
		self.textabout.insert(END, '\n' , 'norm')			
		self.textabout.insert(END, 'Sourceforge - ' , 'norm')	
		self.textabout.insert(END, 'http://www.sourceforge.net/' , 'hlink')			
		self.textabout.insert(END, '\n' , 'norm')					
		self.textabout.insert(END, 'Python - ' , 'norm')	
		self.textabout.insert(END, 'http://www.python.org' , 'hlink')			
		self.textabout.insert(END, '\n' , 'norm')	
		self.textabout.insert(END, 'Tkinter - ' , 'norm')	
		self.textabout.insert(END, 'http://www.pythonware.com' , 'hlink')			
		self.textabout.insert(END, '\n' , 'norm')	
		self.textabout.insert(END, 'Python Win32 Extentions - ' , 'norm')	
		self.textabout.insert(END, 'http://starship.python.net/crew/mhammond/' , 'hlink')			
		self.textabout.insert(END, '\n' , 'norm')	
		self.textabout.insert(END, 'Active State - ' , 'norm')	
		self.textabout.insert(END, 'http://www.activestate.com/' , 'hlink')			
		self.textabout.insert(END, '\n' , 'norm')			
		self.textabout.insert(END, 'Leo - ' , 'norm')	
		self.textabout.insert(END, 'http://sourceforge.net/projects/leo/' , 'hlink')			
		self.textabout.insert(END, '\n' , 'norm')			
		self.textabout.insert(END, 'Ghost Installer - ' , 'norm')	
		self.textabout.insert(END, 'http://www.ginstall.com/' , 'hlink')			
		#contact info				
		self.textabout.insert(END, '\n\n', 'norm')					
		self.textabout.insert(END, 'Contact Information', 'head3')			
		self.textabout.insert(END, '\n\n', 'norm')						
		self.textabout.insert(END, "Email the author at ", 'norm')		
		self.textabout.insert(END, "sayzme@datafurnace.net.au", 'hlink')
		self.textabout.insert(END, " - feedback is appreciated. \n\n", 'norm')		
		self.textabout.insert(END, "Visit the website at ", 'norm')		
		self.textabout.insert(END, 'http://sayzme.sourceforge.net', 'hlink')		
		self.textabout.insert(END, " for the latest updates. ", 'norm')				
		self.textabout.insert(END, '\n\n', 'norm')						
		#license
		self.textabout.insert(END, 'License', 'head3')			
		self.textabout.insert(END, '\n\n', 'norm')		
		info = 'Copyright (c) 2002. Adam Bunter. All rights reserved.\n\n'
		self.textabout.insert(END, info, 'norm')			                
		info = 'Redistribution and use in source and binary forms, ' \
		'with or without modification, are permitted provided that the ' \
		'following conditions are met:\n\n'
		self.textabout.insert(END, info, 'norm')	
		info = '- Redistributions of source code must retain the above copyright notice, ' \
		'this list of conditions and the following disclaimer.\n'
		self.textabout.insert(END, info, 'point')	
		info = '- Redistributions in binary form must reproduce the above copyright notice, ' \
		'this list of conditions and the following disclaimer in the documentation and/or other ' \
		'materials provided with the distribution.\n'
		self.textabout.insert(END, info, 'point')	
		info = '- Neither the name of the Adam Bunter nor the names of its contributors may be ' \
		'used to endorse or promote products derived from this software without ' \
		'specific prior written permission.\n\n'
		self.textabout.insert(END, info, 'point')			

		info = 'THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND ' \
		'CONTRIBUTORS \"AS IS\" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, ' \
		'BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS ' \
		'FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT ' \
		'OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, ' \
		'EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, ' \
		'PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR ' \
		'PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF ' \
		'LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE ' \
		'OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ' \
		'ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.'		
		self.textabout.insert(END, info, 'norm')	

	def openHLink(self, event):
		start, end = self.textabout.tag_prevrange("hlink", self.textabout.index("@%s,%s" % (event.x, event.y)))
		link =  self.textabout.get(start, end)
		# os.system("start " + link) #no good - locks up if no console window
		win32api.ShellExecute(0, None, link, None, None, win32con.SW_SHOW)		 
		# import webbrowser #another method
		#webbrowser.open(link)

	def hand_cursor(self, event):
		self.textabout.config(cursor="hand2")
		return None

	def normal_cursor(self, event):
		self.textabout.config(cursor="")
		return None



#@-body
#@-node:2::<<dialog about>>


#@<<dialog engine options>>
#@+node:3::<<dialog engine options>>
#@+body
class EngineOptions:
	def __init__(self, master):
		dialog = Toplevel()
		self.dialog = dialog
		#self.dialog.transient()				
		dialog.title("Sayz Me - Speech Engine")
		dialog.iconname('sayzme')
		dialog.iconbitmap('sayzme.ico')
		frame_about = Frame(dialog)

		options = [('Engine Id:', 'Festival'),  
				   ('Manufacturer:', 'tbc'),
				   ('Mode Id:', 'tbc'),
				   ('Speaker:', 'tbc'),
				   ('Style:', 'tbc'),
				   ('Dialect:', 'tbc')]
		info ='\n'
		for option in options:
				info = info + ("  %-15s %s  \n" % option)
		label_engine = Label(dialog, 
		foreground='black', 
		borderwidth=1, 
		relief='groove', 
		text=info, 
		justify="left", 
		wraplength=600, 
		font='Courier 8')
		label_engine.grid(row=0, columnspan=2)

		#exit button        
		self.button = Button(dialog, 
		text='Exit', 
		foreground='DarkRed', 
		activeforeground ='DarkRed', 
		width = 10, 
		command=dialog.destroy)
		#self.button.grid(row=3, columnspan=2)
		#test button
		self.button = Button(dialog, 
		text='Test',  
		foreground='DarkBlue', 
		activeforeground ='Blue', 
		width = 10, 
		command=master.doTest)
		#self.button.grid(row=3, columnspan=2)
		#fill empty space
		self.label = Label (dialog)
		#self.button.grid(row=3, columnspan=2)
		self.centerMe()
		#dialog.grab_set()
				
	def centerMe(self):
		#center
		top = self.dialog
		top.update()
		sw = top.winfo_screenwidth()
		sh = top.winfo_screenheight()
		w = top.winfo_width()
		h = top.winfo_height()
		x = (sw - w)/2
		y = (sh - h)/2
		geom = '%dx%d+%d+%d' % (w, h, x, y)
		top.geometry(geom)	
		return None

#@-body
#@-node:3::<<dialog engine options>>


#@<<application>>
#@+node:4::<<application>>
#@+body
class App:
	
	#@<<init>>
	#@+node:1::<<init>>
	#@+body
	def __init__(self, master):
		#initialise
		self.master = master        
		
		#@<<frames>>
		#@+node:1::<<frames>>
		#@+body
		#create frames
		frame_status = Frame(master)
		frame_status.pack(side=BOTTOM, fill=X)
		frame_text = Frame(master)
		frame_text.pack(side=TOP, fill=BOTH, expand=YES)
		frame_button = Frame(master)
		frame_button.pack(side=BOTTOM, fill=X)           
		frame_visual=Frame(master)
		frame_visual.pack(side=TOP, fill=X)
		
		#@-body
		#@-node:1::<<frames>>
   
		
		#@<<global variables>>
		#@+node:2::<<global variables>>
		#@+body
		#initialise global variables
		global gspeaking
		gspeaking = int(0)
		global ghide
		ghide = int(0)
		global gwordposition
		gwordposition = int(0)
		global gcharposition
		gcharposition = int(0)
		global gpaused
		gpaused = int(0)
		global gwords
		gwords = string.split('Welcome to Sayz Me.')
		global gwordpositionjumpto
		gwordpositionjumpto=int(0)
		#@-body
		#@-node:2::<<global variables>>
        
	    
		#@<<app variables>>
		#@+node:3::<<app variables>>
		#@+body
		#initialise app variables
		self.wordposition = int(0)
		self.charposition = int(0)
		self.words=string.split('Welcome to Sayz Me.')    
		#initialse options and set defaults
		self.paused = IntVar()
		self.paused.set(0)
		self.countposition = StringVar()
		self.countposition.set('')
		self.listen_to_clip = IntVar()
		self.listen_to_clip.set(1)
		self.empty_clip = IntVar()        
		self.empty_clip.set(1)
		self.to_top = IntVar()
		self.to_top.set(1)
		self.min_after_speak = IntVar()
		self.min_after_speak.set(1)
		self.speed = IntVar()
		self.speed.set(150)
		self.pitch = IntVar()
		self.pitch.set(140)
		self.volume = IntVar()      
		self.highlight_leading = IntVar()
		self.highlight_leading.set(5)
		self.highlight_trailing = IntVar()
		self.highlight_trailing.set(20)
		self.reading_color = StringVar()
		self.greeting = IntVar()
		self.greeting.set(1)
		self.festival = StringVar()
		self.festival.set('c:\festival\bin\festival.exe')
		self.speakfile = 'speak.txt'
		# set saved options
		self.GetOpts()  
		self.SetOpts()  
		
		#@-body
		#@-node:3::<<app variables>>

		
		#@<<build ui>>
		#@+node:4::<<build ui>>
		#@+body
		#set title and build menu 
		master.iconname('sayzme')
		master.iconbitmap('sayzme.ico')        
		master.title("Sayz Me")
		self.build_menu(master)        
		#count label as status bar
		self.label = Label (frame_status, 
		foreground='black', 
		textvariable=self.countposition, 
		bd=1, 
		relief=SUNKEN, 
		anchor=W, 
		font='Arial 7')
		self.label.pack(side=BOTTOM, fill=X) 
		
		#text widget        
		self.scroll = Scrollbar(frame_text, orient='vertical')
		self.scroll.pack (fill=Y, side=RIGHT)
		self.text = Text(frame_text, wrap='word', font='Arial 12', yscrollcommand=self.scroll.set)
		self.text.bind('<Double-1>', self.JumpTo)
		self.text.pack (side=LEFT, fill=BOTH, expand=YES)
		self.scroll.config(command=self.text.yview)
		if self.greeting.get()==1:
			self.text.insert(END,"Welcome to sayz-me.")
		self.text.tag_config("spoken", foreground = 'grey40')
		self.text.tag_config('speaking', foreground = self.reading_color.get())
		#pause button
		self.checkbutton = Checkbutton(frame_button, 
		text='Pause', 
		foreground='DarkBlue', 
		width = 10, 
		indicatoron=0, 
		variable = self.paused,  
		command= self.AudioPauseResume)
		self.checkbutton.pack (side=LEFT, padx = 2, pady = 5)
		#exit button        
		self.button = Button(frame_button, 
		text='Exit', 
		foreground='DarkRed', 
		activeforeground ='DarkRed', 
		width = 10, 
		command=frame_button.quit)
		self.button.pack (side=RIGHT, padx = 2, pady = 5)        
		#reset button
		self.button = Button(frame_button, 
		text='Reset', 
		foreground='Red', 
		activeforeground ='Red', 
		width = 10, 
		command=self.Reset)
		self.button.pack (side=RIGHT, padx = 2, pady = 5)
		#ReadAgain button
		self.button = Button(frame_button, 
		text='Read', 
		foreground='DarkGreen', 
		activeforeground ='DarkGreen', 
		width = 10, command=self.ReadAgain)
		self.button.pack (side=RIGHT, padx = 2, pady = 5)	
		#fill empty space
		self.label = Label (frame_button, width=4)
		self.label.pack(side=LEFT)
		
		#visual
		visual_canvas = Canvas(frame_visual, background='black', height=40)
		#visual_canvas.pack(fill=X)
		
		
		
		#resize
		self.MaximizeMe()
		#@-body
		#@-node:4::<<build ui>>

	
		#timer for display update
		self.id = self.label.after(250, self.timer)
	
	#@-body
	#@-node:1::<<init>>

	
	#@<<timer>>
	#@+node:2::<<timer>>
	#@+body
	def timer(self):
		#get clipboard text or update display
		global gspeaking
		global gpaused
		time.sleep(0)
		if gspeaking == 0:
			if gpaused == 0:
				self.text.tag_remove('speaking', '0.0', 'end')
				self.text.tag_remove('spoken', '0.0', 'end')
				global ghide
				if ghide==1: self.MinimizeMe()
				ghide = 0
			self.WinClip()   
		else:
			gpaused = 0
			global gcharposition
			charspeaking = gcharposition + self.highlight_trailing.get() 
			charspoken = gcharposition - self.highlight_leading.get()          
			self.text.tag_remove('speaking', '0.0', 'end')
			self.text.tag_remove('spoken', '0.0', 'end')				
			self.text.tag_add('speaking', '0.0', '0.0 + ' + str(charspeaking) + ' char wordend')                
			self.text.tag_add('spoken', '0.0', '0.0 + ' + str(charspoken) + 'char wordstart')
			self.text.tag_lower('speaking', 'spoken')
			self.text.see('0.0 + ' + str(charspeaking) + ' char wordend')           
			countposition = (" Word: " + str(gwordposition) + "  Character: " + str(gcharposition))
			self.countposition.set(countposition)      		
		self.id = self.label.after(250, self.timer)
	#@-body
	#@-node:2::<<timer>>

	
	#@<<menus>>
	#@+node:3::<<menus>>
	#@+body
	def OpenAbout(self):   
	    about = AboutMe()
	
	def OpenEngineOptions(self):
	    engine_options = EngineOptions(self)
	    
	def build_menu(self,master):
	    # create menus
	    menu = Menu(master)
	    master.config(menu=menu)
	    
	    menufile = Menu(menu)
	    menu.add_cascade(label="File", menu=menufile)
	    menufile.add_command(label="Open", command=master.quit)
	    menufile.add_separator()	
	    menufile.add_command(label="Exit", command=master.quit)
	    
	    menuoptions = Menu(menu)
	    menu.add_cascade(label="Options", menu=menuoptions)
	    menuoptions.add_checkbutton(label="Say Greeting", variable=self.greeting, command = self.SetOpts)	
	    menuoptions.add_separator()	
	    menuoptions.add_checkbutton(label="Listen to Clipboard", variable=self.listen_to_clip, command = self.SetOpts)
	    menuoptions.add_checkbutton(label="Empty Clipboard", variable=self.empty_clip, command = self.SetOpts)
	    menuoptions.add_separator()
	    menuoptions.add_checkbutton(label="Bring To Top", variable=self.to_top, command = self.SetOpts)
	    menuoptions.add_checkbutton(label="Minimize After Speaking", variable=self.min_after_speak, command = self.SetOpts)
	    menuoptions.add_separator()
	    menuoptions.add_command(label="Settings...", command = self.OpenEngineOptions)
	
	    helpmenu = Menu(menu)
	    menu.add_cascade(label="Help", menu=helpmenu)
	    helpmenu.add_command(label="About...", command=self.OpenAbout)
	#@-body
	#@-node:3::<<menus>>

	
	#@<<min max>>
	#@+node:4::<<min max>>
	#@+body
	def MaximizeMe(self):
		# maximize
		master = self.master
		xoffset = 1
		yoffset = 1
		width = master.winfo_screenwidth() - 10
		height = master.winfo_screenheight() - 80
		master.update()
		master.deiconify()
		master.geometry("%dx%d%+d%+d" % (width, height, xoffset, yoffset))
		master.update()
		return None
	
	def MinimizeMe(self):
		if self.min_after_speak.get() == 1 : self.master.iconify()
		return None
	#@-body
	#@-node:4::<<min max>>

	
	#@<<options>>
	#@+node:5::<<options>>
	#@+body
	def SetOpts(self):
	    try:
	        f=open('optionsf', 'w')
	        opt = {'listen_to_clip': self.listen_to_clip.get(),
	               'empty_clip': self.empty_clip.get(),
	               'to_top': self.to_top.get(),
	               'speed':self.speed.get(),
	               'pitch':self.pitch.get(),
	               'min_after_speak':self.min_after_speak.get(),
	               'highlight_leading':self.highlight_leading.get(),
	               'highlight_trailing':self.highlight_trailing.get(),
	               'reading_color':self.reading_color.get(),
	               'greeting':self.greeting.get(),
	               'festival':self.festival.get()}
	        cPickle.dump(opt, f)
	        f.close
	    except:
	        tkMessageBox.showwarning( "Error", "Unable to save settings!")  
	        f.close
	
	def GetOpts(self):
	    # read saved variables
	    try:
	        f=open('options', 'r')
	        opt = cPickle.load(f)
	        f.read()
	        f.close
	    except IOError:
	        #no file so write defaults
	        f=open('optionsf', 'w')
	        opt = {'listen_to_clip': 1, 'empty_clip': 1, 'to_top': 1, 'speed': 150, 'pitch':160,'min_after_speak':1,
	        'highlight_leading':3, 'highlight_trailing':20, 'reading_color':'Blue', 'greeting':1, 'festival':'c:\festival\bin\festival.exe'}
	        cPickle.dump(opt, f)
	        f.close
	        
	    except:
	        f.close
	        
	    try:
	        self.listen_to_clip.set(opt['listen_to_clip'])
	        self.empty_clip.set(opt['empty_clip'])
	        self.to_top.set(opt['to_top'])
	        self.speed.set(opt['speed'])
	        self.pitch.set(opt['pitch'])
	        self.min_after_speak.set(opt['min_after_speak'])
	        self.highlight_leading.set(opt['highlight_leading'])
	        self.highlight_trailing.set(opt['highlight_trailing'])
	        self.reading_color.set(opt['reading_color'])		
	        self.greeting.set(opt['greeting'])		
	        self.festival.set(opt['festival'])
	
	    except KeyError:
	        self.SetOpts()		
	
	
	#@-body
	#@-node:5::<<options>>

	
	#@<<misc>>
	#@+node:6::<<misc>>
	#@+body
	def MakeBatFile(self):
		#create speaking bat file
		f = 'speak.bat'	
		command = self.festival + ' --tts ' + os.path.abspath(sys.path[0]) + '\speak.txt'
	
	
	def Speak(self, text):
		#speak text
		f=open(self.speakfile, 'w')
		f.write(text)
		f.close()
	
	#	os.execl('c:\festival\bin\festival.exe', "--tts 'this is a test'")
	
		if sys.platform.startswith('win'):
			#os.system('start speak.bat')  # Window
			command = 'c:\\festival\\bin\\festival.exe --tts  c:\\sayzme\\speak.txt'
	#		command = 'start c:\festival\bin\festival.exe --tts c:\sayzme\speak.txt'
	#		os.system(command)
	#		os.popen(command)
	#		win32pipe.popen(command)
	#		os.system('start c:\festival\bin\festival.exe --tts c:\sayzme\speak.txt')
	
			arg = ['--tts c:\\sayzme\\speak.txt']
			fest = "c:\\festival\\bin\\festival.exe"
			proc = os.spawnv(os.P_NOWAIT, fest, ['festival.exe', '--tts c:\\sayzme\\speak.txt'])		
			#print 'proc = ' + str(proc)
			#win32pipe.popen2(command)
	
		else:
			os.system('python myscript.py myargument &')  # Unix
		return None
		
		
		
	#P_WAIT 	obvious
	#P_NOWAIT 	ditto
	#P_NOWAITO 	same as P_NOWAIT apparently
	#P_OVERLAY 	like fork() without exec() (except slower)
	#P_DETACH		background - no opportunity to interact 
		
	def Reset(self):
		# reset
		win32clipboard.OpenClipboard()
		win32clipboard.EmptyClipboard()
		win32clipboard.CloseClipboard()
		#self.directss.AudioReset()
		self.text.delete('1.0','end');
		self.text.insert(END,"Ready.")
		#self.directss.Speak("Ready.")
		return None
	
	def ReadAgain(self):
		#self.directss.AudioReset()
		self.text.tag_remove('speaking', '0.0', 'end')
		self.text.tag_remove('spoken', '0.0', 'end')
		text = self.text.get(1.0,'end')
	#	self.directss.Speak(text)
		self.Speak(text)
		return None
	
	def SetVoiceSpeed(self, speed):
		#self.directss.Speed = self.speed.get()
		self.SetOpts()
		return None
	
	def SetVoicePitch(self, pitch):
		#self.directss.Pitch = self.pitch.get()
		self.SetOpts()
		return None
	
	def SetVoiceVolume(self, volume):
		#self.directss.VolumeLeft = self.volume.get()
		#self.directss.VolumeRight = self.volume.get()
		return None
	
	def SetHighlightTrailing(self, chars):
		self.highlight_leading.set(3)
		self.highlight_trailing.set(chars)
		self.SetOpts()
		return None
	
	def SetReadingColor(self, color):
		self.text.tag_config('speaking', foreground = color)
		self.reading_color.set(color)
		self.SetOpts()
		return None	
	
	def SetGreeting(self, greeting):
		self.SetOpts()
		return None
		
	def AudioPauseResume(self):
		#pause audio
		global gpaused
		if self.paused.get() == 1:
			#self.directss.AudioPause()
			gpaused = 1
		else:
			#f= self.directss.AudioResume()
			gpaused = 1
		return None
	
	def WinClip(self):
		#get windows clipboard text
		if self.listen_to_clip.get() == 1:        
			win32clipboard.OpenClipboard()
			if win32clipboard.IsClipboardFormatAvailable(win32con.CF_TEXT):
				clip_text = win32clipboard.GetClipboardData(win32con.CF_TEXT)
				if self.empty_clip.get() == 1: win32clipboard.EmptyClipboard()
			else:
				clip_text =''
			win32clipboard.CloseClipboard()
				#parse clipboard text
			if len(clip_text) > 0:
				clip_text = self.FormatClipText(clip_text)
				global gpaused
				gpaused = 0
				global gwords
				gwords = string.split(clip_text)
				self.text.delete('1.0','end');
				self.text.insert(END, clip_text)
				global gwordposition
				gwordposition = int(0)
				global gcharposition
				gcharposition = int(0)                     
				if self.to_top.get() == 1: self.MaximizeMe()
				#self.directss.Speak(clip_text)           
				self.Speak(clip_text) 
			return None
	
	def FormatClipText(self, clip_text):
		#format clip text
		while clip_text.find('\t') > -1:
			clip_text = clip_text.replace('\t',' ')        
		while clip_text.find('\r') > -1:
			clip_text = clip_text.replace('\r', '\n')        
		while clip_text.find('\n ') > -1:
			clip_text = clip_text.replace('\n ','\n')            
		while clip_text.find('  ') >-1:
			clip_text = clip_text.replace('  ', ' ')            
		while clip_text.find('\n\n\n') > -1:
			clip_text = clip_text.replace('\n\n\n','\n\n')
		while clip_text.find('\n\n') >-1:
			clip_text = clip_text.replace('\n\n','\n--\n')  
		return clip_text
	
	def JumpTo(self, clip_text):
		#jump to word
		global gwordpositionjumpto
		gpaused
		if gpaused==0:
			self.directss.AudioReset()
			text = self.text.get(1.0,'end')
			wordindex = self.text.index(CURRENT)
			speaktext = self.text.get(wordindex + ' wordstart', 'end')			
			spokentext = self.text.get('0.0', wordindex)
			spokenlist = string.split(spokentext)	  	
			self.directss.Speak(speaktext)		
			gwordpositionjumpto = len(spokenlist)  	
		return None
		
	
	def doNothing(self, na=None):
		return None
		
	def doTest(self, test_text = 'This is a test.'):
		#test speakers voice
		win32clipboard.OpenClipboard()
		win32clipboard.EmptyClipboard()
		win32clipboard.CloseClipboard()
		self.directss.AudioReset()
		self.text.delete('1.0','end');
		self.text.insert(END, test_text)
		self.directss.Speak(test_text)
		return None
	#@-body
	#@-node:6::<<misc>>



#@-body
#@-node:4::<<application>>


#@+others
#@-others

if __name__ == "__main__":
    app = App(root)
    root.mainloop()
#@-body
#@-node:0::@file sayzmef.py
#@-leo
